<?php

// 自动缩略图
function zm_the_thumbnail() {
    global $post;
    if ( get_post_meta($post->ID, 'thumbnail', true) ) {
    	$image = get_post_meta($post->ID, 'thumbnail', true);
        echo '<a href="'.get_permalink().'"><img src=';
        echo $image;
        echo ' alt="'.$post->post_title .'" /></a>';
    } else {
	    if ( has_post_thumbnail() ) {
	        echo '<a href="'.get_permalink().'">';
	        the_post_thumbnail('content', array('alt' => get_the_title()));
	        echo '</a>';
		} else {
	        $content = $post->post_content;
	        preg_match_all('/<img.*?(?: |\\t|\\r|\\n)?src=[\'"]?(.+?)[\'"]?(?:(?: |\\t|\\r|\\n)+.*?)?>/sim', $content, $strResult, PREG_PATTERN_ORDER);
	        $n = count($strResult[1]);
	        if($n > 0){
				if (zm_get_option('timthumb')) {
					echo '<a href="'.get_permalink().'"><img src="'.get_template_directory_uri().'/timthumb.php?src='.$strResult[1][0].'&w='.zm_get_option('img_w').'&h='.zm_get_option('img_h').'&zc=1" alt="'.$post->post_title .'" /></a>';
				} else {
					echo '<a href="'.get_permalink().'"><img src="'.$strResult[1][0].'" alt="'.$post->post_title .'" /></a>';
				}
	        } else { 
				$random = mt_rand(1, 20);
				echo '<a href="'.get_permalink().'"><img src="'.get_template_directory_uri().'/img/random/'. $random .'.jpg" alt="'.$post->post_title .'" /></a>';
	        }
		}
	}
}

function zm_video_thumbnail() {
    global $post;
    $img = get_post_meta($post->ID, 'big', true);
    if ( get_post_meta($post->ID, 'small', true) ) {
    	$image = get_post_meta($post->ID, 'small', true);
        echo '<a class="videos" href="'.$img.'"><img src=';
        echo $image;
        echo ' alt="'.$post->post_title .'" /><i class="fa fa-play-circle-o"></i></a>';
    } else {
	    if ( has_post_thumbnail() ) {
	        echo '<a class="videos" href="'.$img.'">';
	        the_post_thumbnail('content', array('alt' => get_the_title()));
	        echo '<i class="fa fa-play-circle-o"></i></a>';
		}
	}
}

function zm_videos_thumbnail() {
    global $post;
    if ( get_post_meta($post->ID, 'small', true) ) {
    	$image = get_post_meta($post->ID, 'small', true);
        echo '<a class="videos" href="'.get_permalink().'"><img src=';
        echo $image;
        echo ' alt="'.$post->post_title .'" /><i class="fa fa-play-circle-o"></i></a>';
    } else {
	    if ( has_post_thumbnail() ) {
	        echo '<a class="videos" href="'.get_permalink().'">';
	        the_post_thumbnail('content', array('alt' => get_the_title()));
	        echo '<i class="fa fa-play-circle-o"></i></a>';
		}
	}
}

function tao_thumbnail() {
		global $post;
		$url = get_post_meta($post->ID, 'taourl', true);
		if ( get_post_meta($post->ID, 'thumbnail', true) ) {
		$image = get_post_meta($post->ID, 'thumbnail', true);
		echo '<a target="_blank" rel="external nofollow" href="'.$url.'"><img src=';
		echo $image;
		echo ' /></a>';
    } else {
	    $content = $post->post_content;
	    preg_match_all('/<img.*?(?: |\\t|\\r|\\n)?src=[\'"]?(.+?)[\'"]?(?:(?: |\\t|\\r|\\n)+.*?)?>/sim', $content, $strResult, PREG_PATTERN_ORDER);
	    $n = count($strResult[1]);
	    if($n > 0){
	        echo '<a href="'.$url.'"><img src="'.$strResult[1][0].'" alt="'.$post->post_title .'" /></a>';
	    }
	}
}

function zm_the_thumbnail_h() {
    global $post;
    if ( get_post_meta($post->ID, 'thumbnail', true) ) {
    	$image = get_post_meta($post->ID, 'thumbnail', true);
        echo '<a href="'.get_permalink().'"><img src="' . get_template_directory_uri() . '/img/loading.gif" data-echo=';
        echo $image;
        echo ' alt="'.$post->post_title .'" /></a>';
    } else {
	    if ( has_post_thumbnail() ) {
	        echo '<a href="'.get_permalink().'">';
	        the_post_thumbnail('content', array('alt' => get_the_title()));
	        echo '</a>';
		} else {
	        $content = $post->post_content;
	        preg_match_all('/<img.*?(?: |\\t|\\r|\\n)?src=[\'"]?(.+?)[\'"]?(?:(?: |\\t|\\r|\\n)+.*?)?>/sim', $content, $strResult, PREG_PATTERN_ORDER);
	        $n = count($strResult[1]);
	        if($n > 0){
				if (zm_get_option('timthumb')) {
					echo '<a href="'.get_permalink().'"><img src="'.get_template_directory_uri().'/timthumb.php?src='.$strResult[1][0].'&w='.zm_get_option('img_w').'&h='.zm_get_option('img_h').'&zc=1" alt="'.$post->post_title .'" /></a>';
				} else {
					echo '<a href="'.get_permalink().'"><img src="' . get_template_directory_uri() . '/img/loading.gif" data-echo="'.$strResult[1][0].'" alt="'.$post->post_title .'" /></a>';
	            }
	        } else { 
	        	$random = mt_rand(1, 20);
				echo '<a href="'.get_permalink().'"><img src="' . get_template_directory_uri() . '/img/loading.gif" data-echo="'.get_template_directory_uri().'/img/random/'. $random .'.jpg" alt="'.$post->post_title .'" /></a>';
	        }
		}
	}
}

function zm_videos_thumbnail_h() {
    global $post;
    if ( get_post_meta($post->ID, 'small', true) ) {
    	$image = get_post_meta($post->ID, 'small', true);
        echo '<a class="videos" href="'.get_permalink().'"><img src="' . get_template_directory_uri() . '/img/loading.gif" data-echo=';
        echo $image;
        echo ' alt="'.$post->post_title .'" /><i class="fa fa-play-circle-o"></i></a>';
    } else {
	    if ( has_post_thumbnail() ) {
	        echo '<a class="videos" href="'.get_permalink().'">';
	        the_post_thumbnail('content', array('alt' => get_the_title()));
	        echo '<i class="icon-btnPlay"></i></a>';
		}
	}
}

function zm_videor_thumbnail_h() {
    global $post;
    if ( get_post_meta($post->ID, 'small', true) ) {
    	$image = get_post_meta($post->ID, 'small', true);
        echo '<a class="videor" href="'.get_permalink().'"><img src="' . get_template_directory_uri() . '/img/loading.gif" data-echo=';
        echo $image;
        echo ' alt="'.$post->post_title .'" /><i class="fa fa-play-circle-o"></i></a>';
    } else {
	    if ( has_post_thumbnail() ) {
	        echo '<a class="videor" href="'.get_permalink().'">';
	        the_post_thumbnail('content', array('alt' => get_the_title()));
	        echo '<i class="icon-btnPlay"></i></a>';
		}
	}
}

function zm_videor_thumbnail() {
    global $post;
    if ( get_post_meta($post->ID, 'small', true) ) {
    	$image = get_post_meta($post->ID, 'small', true);
        echo '<a class="videor" href="'.get_permalink().'"><img src=';
        echo $image;
        echo ' alt="'.$post->post_title .'" /><i class="fa fa-play-circle-o"></i></a>';
    } else {
	    if ( has_post_thumbnail() ) {
	        echo '<a class="videor" href="'.get_permalink().'">';
	        the_post_thumbnail('content', array('alt' => get_the_title()));
	        echo '<i class="icon-btnPlay"></i></a>';
		}
	}
}

function tao_thumbnail_h() {
		global $post;
		$url = get_post_meta($post->ID, 'taourl', true);
		if ( get_post_meta($post->ID, 'thumbnail', true) ) {
		$image = get_post_meta($post->ID, 'thumbnail', true);
		echo '<a target="_blank" rel="external nofollow" href="'.$url.'"><img src="' . get_template_directory_uri() . '/img/loading.gif" data-echo=';
		echo $image;
		echo ' /></a>';
    } else {
	    $content = $post->post_content;
	    preg_match_all('/<img.*?(?: |\\t|\\r|\\n)?src=[\'"]?(.+?)[\'"]?(?:(?: |\\t|\\r|\\n)+.*?)?>/sim', $content, $strResult, PREG_PATTERN_ORDER);
	    $n = count($strResult[1]);
	    if($n > 0){
	        echo '<a href="'.$url.'"><img src="' . get_template_directory_uri() . '/img/loading.gif" data-echo="'.$strResult[1][0].'" alt="'.$post->post_title .'" /></a>';
	    }
	}
}